#include "../cplib/lw.h"
#include "../cplib/dib.h"
#include "ika.h"
#include "resource.h"


class IkaWnd : public BaseWnd {
protected:
	static BOOL register_flag;
	DIB* off;
public:
	BOOL registeredP() { return register_flag; }
	void setRegisterFlag() { register_flag = TRUE; }
	LPSTR getMenuName() { return "MAINMENU"; }
	LPSTR getCaptionStr() { return "IKATECH Windows GDI Edition"; }

	void onOpenChildWindow();
	void onPaint(HDC hDC);
	void onTimer();
	void onResize(RECT* r);
	USHORT onMenu(WPARAM wparam, LPARAM lparam);

	IkaWnd() : BaseWnd() {}
};



BOOL
IkaWnd::register_flag = FALSE;


void
IkaWnd::onResize(RECT* rsrc)
{
	RECT r, rw;

	GetClientRect(&r);
	GetWindowRect(&rw);

	MoveWindow(rw.left, rw.top, 
		(rw.right - rw.left) - (r.right - r.left) + SCREEN_WIDTH,
		(rw.bottom - rw.top) - (r.bottom - r.top) + SCREEN_HEIGHT, TRUE);
}


void
IkaWnd::onOpenChildWindow()
{
	HDC hDC = GetDC();
	off = DIB::createCompatibleDIB(SCREEN_WIDTH, SCREEN_HEIGHT, hDC, NULL, 0, NULL);
	ReleaseDC(hDC);

	setup_ikatech();
	setTimer(20);
}


void
IkaWnd::onTimer()
{
	HDC localDC = GetDC();
	HBITMAP oldbmp;
	HBITMAP hbmp = CreateCompatibleBitmap(localDC, SCREEN_WIDTH, SCREEN_HEIGHT);
	hDC = CreateCompatibleDC(localDC);
	oldbmp = (HBITMAP)SelectObject(hDC, hbmp);
	if (timer_job()) {
		PostQuitMessage(0);
	}
	BitBlt(localDC, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, hDC, 0, 0, SRCCOPY);
	SelectObject(hDC, oldbmp);
	DeleteObject(hbmp);
	DeleteDC(hDC);
	ReleaseDC(localDC);
}


void
IkaWnd::onPaint(HDC hDC)
{
}


USHORT
IkaWnd::onMenu(WPARAM wparam, LPARAM lparam)
{
	if (lparam==GET_MENU_STATE) {
		switch(wparam) {
		case IDM_ENDING:
			return MF_ENABLED;
		case IDM_QUIT:
			return MF_ENABLED;
		case IDM_START:
			if (get_game_state()==GAME_STATE_OPENING) {
				return MF_ENABLED;
			} else {
				return MF_DISABLED | MF_GRAYED;
			}
		case IDM_WIRE:
			if (flag_pol==1) {
				return MF_ENABLED;
			} else {
				return MF_ENABLED | MF_CHECKED;
			}
		case IDM_BR:
			if (flag_br) {
				return MF_ENABLED | MF_CHECKED;
			} else {
				return MF_ENABLED;
			}
		case IDM_USERINH:
			if (flag_user_inh) {
				return MF_ENABLED | MF_CHECKED;
			} else {
				return MF_ENABLED;
			}
		}
	} else {
		switch(wparam) {
		case IDM_QUIT:
			PostQuitMessage(0);
			break;
		case IDM_START:
			force_game_start = 1;
			break;
		case IDM_BR:
			flag_br = flag_br ? 0: 1;
			break;
		case IDM_USERINH:
			flag_user_inh = flag_user_inh ? 0 : 1;
			break;
		case IDM_WIRE:
			flag_pol = flag_pol ? 0 : 1;
			break;
		case IDM_ENDING:
			set_game_state(GAME_STATE_ENDING_SETUP);
			break;
		}
	}
	return 0;
}



int
Main()
{
	IkaWnd* wnd = new IkaWnd();
	wnd->openWindow();
	MSWin::MessageLoop();
	return 0;
}


