#ifndef	__ika_h__
#define	__ika_h__

#ifdef _WIN32
#include <windows.h>
#endif

#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 400

#ifdef	NDEBUG
#define	D(s)
#else
#define	D(s)	s
#endif

#include <stdio.h>


/* CONSTANT VALUE ? */
#define	G_LIMIT_X	(319)		/* ۲̤ˤ */
#define	G_LIMIT_Y	(199)

#define		SINBASE		(8192)
#define		V_BALCAN	(512)
#define		V_MISSILE	(1024)
#define		V_LASER		(2048)
#define		DIV_BAL8k	((short)(SINBASE/V_BALCAN))
#define		DIV_MIS8k	((short)(SINBASE/V_MISSILE))
#define		DIV_LASER8k	((short)(SINBASE/V_LASER))
#define		SFT_SIN8k	(13)
#define		SFT_BAL8k	((short)4)
#define		SFT_MIS8k	((short)3)
#define		SFT_LASER8k	((short)2)


#define MAX_OBJECT 256		/* 祪֥ȿ */
#define MAX_MODELS 100		/* ɲǽʥǥ */
#define MAX_TYPES  20		/* 絡 */


#define MODE_NORMAL 0			/* ư⡼ */
#define MODE_EXPLOSION 1
#define MODE_HIT 2
#define MODE_EMS 3
#define MODE_REVERSE 4


#define TYPE_OBJ 0				/* ֥ȤΥ */
#define TYPE_IKA 1
#define TYPE_MISSILE 2
#define TYPE_BALCAN 3
#define TYPE_USER 4
#define TYPE_LASER 5
#define TYPE_TERM 6

#define MODEL_MIS 0				/* åǥ */
#define MODEL_BAL 1
#define MODEL_LASER 2
#define MODEL_EXP1 3
#define MODEL_EXP2 4

#define SOUND_BASE 0			/* ֹ */
#define SOUND_MIS 1
#define SOUND_LASER 2
#define SOUND_BAL 3
#define SOUND_EXP 4
#define SOUND_PYU 5
#define SOUND_ENDING 6

#define KEY6 1					/* 󥳡 */
#define KEY2 2
#define KEY8 4
#define KEY4 8
#define KEYQ 0x10
#define KEYW 0x20
#define KEYE 0x40
#define KEYESC 0x80
#define KEYSPACE 0x100
#define KEYZ 0x200
#define KEYX 0x400
#define KEYC 0x800
#define KEY7 0x1000
#define KEY9 0x2000

// WindowsǤΤοʹԤ򥹥ơȤȤäƴƤ
// ơȤİȤǡ_SETUP򤹤ȡ塢ΥơȤ˿ʤߡΥơȤλޤƱư򤹤
// δưika.ctimer_job()ǴƤ
#define GAME_STATE_OPENING_SETUP 0	// ץ˥
#define GAME_STATE_OPENING 1	// ץ˥
#define GAME_STATE_GATE_OPEN_SETUP 2 // ȥץ
#define GAME_STATE_GATE_OPEN 3	// ȥץ
#define GAME_STATE_GAME_SETUP 4	// 
#define GAME_STATE_GAME 5		// 
#define GAME_STATE_GATE_CLOSE_SETUP 6 // ȥ
#define GAME_STATE_GATE_CLOSE 7	// ȥ
#define GAME_STATE_STATUS_CHECK 8 // η̤ǧ륹ơ
#define GAME_STATE_ENDING_SETUP 10 // ǥ
#define GAME_STATE_ENDING 11	// ǥ
#define GAME_STATE_FINISH 12

/*  */

typedef struct IKATYPE {
	char name[20];
	int model[10];
	int thinkpat;
	int HP;
	long maxspeed;
	int basecount;
	int miscount;
	int balcount;
	int height;
	int weight;
	int hps;
	char comment[80];
} IKATYPE;

// ǥɽ
typedef struct IKA_POINT {
	long x;
	long y;
	long z;
} IKA_POINT;


typedef struct PARTS_POLIGON {
	char type;
	char color;
	short p[4];
} PARTS_POLIGON;


typedef struct MODEL {
	char name[50];
	IKA_POINT *point;
	PARTS_POLIGON *partspoligon;
	long r;					/* Ⱦ */
	int points;
	int pols;
	int link;
} MODEL;


// ¹ԻΥ֥ɽ
typedef struct OBJECT {
	short majtype;
	long x;
	long y;
	long z;
	short rad;
	short model;		/* ɽΥǥʥС */
	short modelbase[10];	/* ǥꥹ(ikaΤߤ˻) [0]=Ż [1][2]= ʲȯ */
	short af;			/* ˥Υե졼ʥС(Ԥ˻) */
	short work[6];
	short mis;		/* ߥκƽŶ */
	short bal;		/* Х륫κƽŶ */
	short laser;		/* 졼κƽŶ */
	long speed;
	long maxspeed;	/* ® */
	short miscount;	/* ߥΥ */
	short balcount;	/* Х륫ο */
	short thinkpat;	/* ׹ͥѥ */
	short basecount;	/* 졼ʤɤκƽŶ */
	short bef;
	short next;
	short id;
} OBJECT;


#ifdef __cplusplus
extern "C" {
#endif

extern OBJECT objs[];
extern MODEL models[];
extern short freecell, otop, objfree;
extern short sp, stage[];
extern short cos8k[361], sin8k[361];
extern int stages;
extern int flag_br;			/* Хȥ */
extern int ikacount;		/*  */
extern int freemodel;					/* ɤƤǥο */
extern int force_game_start;  // ॹ(openingˤ1ˤȶŪ˥Ȥ)
extern int flag_user_inh, flag_pol;	/* ưե饰 */
extern IKATYPE	IkaType[MAX_TYPES];		/* ε */
extern int		ikatypes;				// ε



/* ƵΥåȥå */
extern void	SetupJob( void );
extern void	EndJob( int sig );
extern void	AbortJob( int sig );

/* ɽ (view.c) */
void pol1(int x1, int y1,int x2, int y2, int x3, int y3, int color);
void Redraw(int sy, int rx, int ry, int rz, int dx, int dy, int dz, int pmode);

/* ޥ¸롼 ɥ١å */
extern int	GetKey( void );
extern void	target_scope(void);
extern void	LaderScreen( int m, int range, long d, int inh);
extern void	Sound(int sn, int o);
extern void	BaseSound(int sn);
//extern void	SoundOn(void);
extern void	Flash(void);

/* extra macro */
#define	PRINTS( m )	puts( m )
#define	EXIT( rc )	exit( rc )


#define abs(c) ((c)<0?-(c):c)

extern int search_model(char* name);
extern int add_model(char* name, int points, int pols, int r, int point[][3], int poligon[][6]);

// ޡưΤδå롼
void set_timer_callback(int (*func)());
int timer_job();
int get_game_state();  // ơȤμ
void set_game_state(int state);  // ơȤѹ

// 롼
void pset(int x1, int y1, int col);
void bf(int x1, int y1, int x2, int y2, int col);
void pol(int x1, int y1, int x2, int y2, int x3, int y3, int col);
void line(int x1, int y1, int x2, int y2, int col);
void cl1(int col1);
void cl(int col1, int col2);
void gcls(void);		/* ɽõ */
void disp_str(int x, int y, int x1, int y1, char* str);


/* ֥ȴ롼 (exec.c) */
void objdrop(int ob);
int  objget(void);
void objadd(int o);
void objclear(void);

/* ưȽ롼 (exec.c) */
int EmsCheck(int m, long dx, long dz);

/* ֥Ƚ롼 (exec.c) */
void GenWeapons(int m);
int user_exec(int m, long *d, int *range, int *y);
int missile_exec(int m);
int balcan_exec(int m);
int laser_exec(int m);
int ika_exec(int m);


/* ׹֥ͥ롼 (ikathink.c) */
int RollLeft(int m);
int RollRight(int m);
long SpeedUp(int m);
long SpeedDown(int m);
void ika_think(int m);
void ika_think2(int m);
void baka_think(int m);
void pil_think(int m);

void setup_model();
int setup_ikatype();
int load_stage(int num);
void setup_ikatech();

#ifdef _WIN32
extern HDC hDC;
#endif

#ifdef __cplusplus
};
#endif


#endif

